//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 DimGray
#property indicator_color2 Yellow
#property indicator_color3 Olive
#property indicator_color4 Olive
#property indicator_color5 Orange
#property indicator_color6 Orange
#property indicator_color7 Gray
#property indicator_color8 Gray
#property indicator_width1 2

//
//
//
//
//

extern string TimeFrame     = "Current time frame";
extern int    LR.length     = 55;
extern double std.channel.1 =  1;
extern double std.channel.2 =  2;
extern double std.channel.3 =  3;
extern int    Price         = PRICE_CLOSE;
extern string UseSymbol     = "";
extern bool   Interpolate   = true;

//
//
//
//
//

double lrBuffer[];
double upBuffer1[];
double dnBuffer1[];
double upBuffer2[];
double dnBuffer2[];
double upBuffer3[];
double dnBuffer3[];
double prices[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,prices);
   SetIndexBuffer(1,lrBuffer);  SetIndexLabel(0,"mean");
   SetIndexBuffer(2,upBuffer1); SetIndexLabel(1,"1st Std up");
   SetIndexBuffer(3,dnBuffer1); SetIndexLabel(2,"1st Std down");
   SetIndexBuffer(4,upBuffer2); SetIndexLabel(3,"2nd Std up");
   SetIndexBuffer(5,dnBuffer2); SetIndexLabel(4,"2nd Std down");
   SetIndexBuffer(6,upBuffer3); SetIndexLabel(5,"3rd Std up");
   SetIndexBuffer(7,dnBuffer3); SetIndexLabel(6,"3rd Std down");
   
      //
      //
      //
      //
      //

      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit() {}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,i,n,counted_bars=IndicatorCounted();
   string symbol;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { prices[0] = limit+1; return(0); }
           if (iOpen(UseSymbol,0,0)==0)
                  symbol = Symbol();
           else   symbol = UseSymbol;

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(i=limit; i>=0; i--)
      {
         prices[i] = iMA(symbol,0,1,0,MODE_SMA,Price,i);
         
         double slope;
         double value   = iLRValue(slope,LR.length,i);
         double std.dev = 0;

            for(int k=0; k<LR.length; k++)
            {
               double diff = prices[i+k]-(value-k*slope);
                  std.dev += diff*diff;
            }
            std.dev = MathSqrt(std.dev/(LR.length-1.0));
      
         //
         //
         //
         //
         //
      
         lrBuffer[i]  = value;
         upBuffer1[i] = lrBuffer[i]+(std.channel.1*std.dev);
         dnBuffer1[i] = lrBuffer[i]-(std.channel.1*std.dev);
         upBuffer2[i] = lrBuffer[i]+(std.channel.2*std.dev);
         dnBuffer2[i] = lrBuffer[i]-(std.channel.2*std.dev);
         upBuffer3[i] = lrBuffer[i]+(std.channel.3*std.dev);
         dnBuffer3[i] = lrBuffer[i]-(std.channel.3*std.dev);
      }
      if (!calculateValue) IndicatorShortName("prd "+symbol+" ("+LR.length+")");
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(symbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         prices[i]    = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,std.channel.3,Price,0,y);
         lrBuffer[i]  = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,std.channel.3,Price,1,y);
         upBuffer1[i] = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,std.channel.3,Price,2,y);
         dnBuffer1[i] = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,std.channel.3,Price,3,y);
         upBuffer2[i] = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,std.channel.3,Price,4,y);
         dnBuffer2[i] = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,std.channel.3,Price,5,y);
         upBuffer3[i] = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,std.channel.3,Price,6,y);
         dnBuffer3[i] = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,std.channel.3,Price,7,y);

         //
         //
         //
         //
         //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
            {
               prices[i+k]    = prices[i]    + (prices[i+n]   -prices[i]   )*k/n;
               lrBuffer[i+k]  = lrBuffer[i]  + (lrBuffer[i+n] -lrBuffer[i] )*k/n;
               upBuffer1[i+k] = upBuffer1[i] + (upBuffer1[i+n]-upBuffer1[i])*k/n;
               dnBuffer1[i+k] = dnBuffer1[i] + (dnBuffer1[i+n]-dnBuffer1[i])*k/n;
               upBuffer2[i+k] = upBuffer2[i] + (upBuffer2[i+n]-upBuffer2[i])*k/n;
               dnBuffer2[i+k] = dnBuffer2[i] + (dnBuffer2[i+n]-dnBuffer2[i])*k/n;
               upBuffer3[i+k] = upBuffer3[i] + (upBuffer3[i+n]-upBuffer3[i])*k/n;
               dnBuffer3[i+k] = dnBuffer3[i] + (dnBuffer3[i+n]-dnBuffer3[i])*k/n;
            }               
   }
   IndicatorShortName(timeFrameToString(timeFrame)+" prd "+symbol+" ("+LR.length+")");   
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
//
//
//
//
//

int    lr.period=0;
double lr.sumX;
double lr.sumXSqr;
double lr.divisor;

//
//
//
//
//

double iLRValue(double& LinearRegSlope, int len, int shift)
{
   double LinearRegValue;
   double Intercept;
   double SumXY = 0;
   double SumY  = 0;

   //
   //
   //
   //
   //

   if (lr.period != len)
   {
      lr.period  = len;
      lr.sumX    = lr.period * (lr.period-1) / 2.0;
      lr.sumXSqr = lr.period * (lr.period-1) * (2.0 * lr.period - 1.0) / 6.0;
      lr.divisor = MathPow(lr.sumX,2.0) - lr.period * lr.sumXSqr;
   }

   //
   //
   //
   //
   //

   for (int i=0; i<lr.period; i++)
   {
      double price = prices[i+shift];
            SumXY += i*price;
            SumY  +=   price;
   }
   if( lr.divisor != 0 ) 
         	LinearRegSlope = (lr.period * SumXY - lr.sumX * SumY)/lr.divisor;
   else     LinearRegSlope = 0; 
   
   //
   //
   //
   //
   //
   
   Intercept      = (SumY - LinearRegSlope * lr.sumX) / lr.period ;
	LinearRegValue = Intercept  + LinearRegSlope * (lr.period-1);
   return(LinearRegValue);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}